diff --git a/src/bks_fmt_plug.c b/src/bks_fmt_plug.c
index dbc5ce8786..1e4575d962 100644
--- a/src/bks_fmt_plug.c
+++ b/src/bks_fmt_plug.c
@@ -215,6 +215,9 @@ static void *get_salt(char *ciphertext)
 	if (cs.format == 0) { // BKS keystore
 		for (i = 0; i < 20; i++)
 			cs.store_hmac[i] = (atoi16[ARCH_INDEX(p[2*i])] << 4) | atoi16[ARCH_INDEX(p[2*i+1])];
+#if !ARCH_LITTLE_ENDIAN && !defined(SIMD_COEF_32)
+		alter_endianity(cs.store_hmac, 20);
+#endif
 	}
 #if !ARCH_LITTLE_ENDIAN && !defined(SIMD_COEF_32)
 	alter_endianity(cs.store_hmac, 20);
